// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcgcd_spl_14:msg/RCGCD.idl
// generated code does not contain a copyright notice
#include "rcgcd_spl_14/msg/detail/rcgcd__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `teams`
#include "rcgcd_spl_14/msg/detail/team_info__functions.h"

bool
rcgcd_spl_14__msg__RCGCD__init(rcgcd_spl_14__msg__RCGCD * msg)
{
  if (!msg) {
    return false;
  }
  // packet_number
  // players_per_team
  // competition_phase
  // competition_type
  // game_phase
  // state
  // set_play
  // first_half
  // kicking_team
  // secs_remaining
  // secondary_time
  // teams
  for (size_t i = 0; i < 2; ++i) {
    if (!rcgcd_spl_14__msg__TeamInfo__init(&msg->teams[i])) {
      rcgcd_spl_14__msg__RCGCD__fini(msg);
      return false;
    }
  }
  return true;
}

void
rcgcd_spl_14__msg__RCGCD__fini(rcgcd_spl_14__msg__RCGCD * msg)
{
  if (!msg) {
    return;
  }
  // packet_number
  // players_per_team
  // competition_phase
  // competition_type
  // game_phase
  // state
  // set_play
  // first_half
  // kicking_team
  // secs_remaining
  // secondary_time
  // teams
  for (size_t i = 0; i < 2; ++i) {
    rcgcd_spl_14__msg__TeamInfo__fini(&msg->teams[i]);
  }
}

bool
rcgcd_spl_14__msg__RCGCD__are_equal(const rcgcd_spl_14__msg__RCGCD * lhs, const rcgcd_spl_14__msg__RCGCD * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // packet_number
  if (lhs->packet_number != rhs->packet_number) {
    return false;
  }
  // players_per_team
  if (lhs->players_per_team != rhs->players_per_team) {
    return false;
  }
  // competition_phase
  if (lhs->competition_phase != rhs->competition_phase) {
    return false;
  }
  // competition_type
  if (lhs->competition_type != rhs->competition_type) {
    return false;
  }
  // game_phase
  if (lhs->game_phase != rhs->game_phase) {
    return false;
  }
  // state
  if (lhs->state != rhs->state) {
    return false;
  }
  // set_play
  if (lhs->set_play != rhs->set_play) {
    return false;
  }
  // first_half
  if (lhs->first_half != rhs->first_half) {
    return false;
  }
  // kicking_team
  if (lhs->kicking_team != rhs->kicking_team) {
    return false;
  }
  // secs_remaining
  if (lhs->secs_remaining != rhs->secs_remaining) {
    return false;
  }
  // secondary_time
  if (lhs->secondary_time != rhs->secondary_time) {
    return false;
  }
  // teams
  for (size_t i = 0; i < 2; ++i) {
    if (!rcgcd_spl_14__msg__TeamInfo__are_equal(
        &(lhs->teams[i]), &(rhs->teams[i])))
    {
      return false;
    }
  }
  return true;
}

bool
rcgcd_spl_14__msg__RCGCD__copy(
  const rcgcd_spl_14__msg__RCGCD * input,
  rcgcd_spl_14__msg__RCGCD * output)
{
  if (!input || !output) {
    return false;
  }
  // packet_number
  output->packet_number = input->packet_number;
  // players_per_team
  output->players_per_team = input->players_per_team;
  // competition_phase
  output->competition_phase = input->competition_phase;
  // competition_type
  output->competition_type = input->competition_type;
  // game_phase
  output->game_phase = input->game_phase;
  // state
  output->state = input->state;
  // set_play
  output->set_play = input->set_play;
  // first_half
  output->first_half = input->first_half;
  // kicking_team
  output->kicking_team = input->kicking_team;
  // secs_remaining
  output->secs_remaining = input->secs_remaining;
  // secondary_time
  output->secondary_time = input->secondary_time;
  // teams
  for (size_t i = 0; i < 2; ++i) {
    if (!rcgcd_spl_14__msg__TeamInfo__copy(
        &(input->teams[i]), &(output->teams[i])))
    {
      return false;
    }
  }
  return true;
}

rcgcd_spl_14__msg__RCGCD *
rcgcd_spl_14__msg__RCGCD__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcd_spl_14__msg__RCGCD * msg = (rcgcd_spl_14__msg__RCGCD *)allocator.allocate(sizeof(rcgcd_spl_14__msg__RCGCD), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcgcd_spl_14__msg__RCGCD));
  bool success = rcgcd_spl_14__msg__RCGCD__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcgcd_spl_14__msg__RCGCD__destroy(rcgcd_spl_14__msg__RCGCD * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcgcd_spl_14__msg__RCGCD__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcgcd_spl_14__msg__RCGCD__Sequence__init(rcgcd_spl_14__msg__RCGCD__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcd_spl_14__msg__RCGCD * data = NULL;

  if (size) {
    data = (rcgcd_spl_14__msg__RCGCD *)allocator.zero_allocate(size, sizeof(rcgcd_spl_14__msg__RCGCD), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcgcd_spl_14__msg__RCGCD__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcgcd_spl_14__msg__RCGCD__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcgcd_spl_14__msg__RCGCD__Sequence__fini(rcgcd_spl_14__msg__RCGCD__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcgcd_spl_14__msg__RCGCD__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcgcd_spl_14__msg__RCGCD__Sequence *
rcgcd_spl_14__msg__RCGCD__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcd_spl_14__msg__RCGCD__Sequence * array = (rcgcd_spl_14__msg__RCGCD__Sequence *)allocator.allocate(sizeof(rcgcd_spl_14__msg__RCGCD__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcgcd_spl_14__msg__RCGCD__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcgcd_spl_14__msg__RCGCD__Sequence__destroy(rcgcd_spl_14__msg__RCGCD__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcgcd_spl_14__msg__RCGCD__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rcgcd_spl_14__msg__RCGCD__Sequence__are_equal(const rcgcd_spl_14__msg__RCGCD__Sequence * lhs, const rcgcd_spl_14__msg__RCGCD__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcgcd_spl_14__msg__RCGCD__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcgcd_spl_14__msg__RCGCD__Sequence__copy(
  const rcgcd_spl_14__msg__RCGCD__Sequence * input,
  rcgcd_spl_14__msg__RCGCD__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcgcd_spl_14__msg__RCGCD);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rcgcd_spl_14__msg__RCGCD * data =
      (rcgcd_spl_14__msg__RCGCD *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcgcd_spl_14__msg__RCGCD__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rcgcd_spl_14__msg__RCGCD__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcgcd_spl_14__msg__RCGCD__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
