// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcgcd_spl_14:msg/RCGCD.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcgcd_spl_14/msg/rcgcd.h"


#ifndef RCGCD_SPL_14__MSG__DETAIL__RCGCD__STRUCT_H_
#define RCGCD_SPL_14__MSG__DETAIL__RCGCD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'COMPETITION_PHASE_ROUNDROBIN'.
enum
{
  rcgcd_spl_14__msg__RCGCD__COMPETITION_PHASE_ROUNDROBIN = 0
};

/// Constant 'COMPETITION_PHASE_PLAYOFF'.
enum
{
  rcgcd_spl_14__msg__RCGCD__COMPETITION_PHASE_PLAYOFF = 1
};

/// Constant 'COMPETITION_TYPE_NORMAL'.
enum
{
  rcgcd_spl_14__msg__RCGCD__COMPETITION_TYPE_NORMAL = 0
};

/// Constant 'COMPETITION_TYPE_CHALLENGE_SHIELD'.
enum
{
  rcgcd_spl_14__msg__RCGCD__COMPETITION_TYPE_CHALLENGE_SHIELD = 1
};

/// Constant 'COMPETITION_TYPE_7V7'.
enum
{
  rcgcd_spl_14__msg__RCGCD__COMPETITION_TYPE_7V7 = 2
};

/// Constant 'COMPETITION_TYPE_DYNAMIC_BALL_HANDLING'.
enum
{
  rcgcd_spl_14__msg__RCGCD__COMPETITION_TYPE_DYNAMIC_BALL_HANDLING = 3
};

/// Constant 'GAME_PHASE_NORMAL'.
enum
{
  rcgcd_spl_14__msg__RCGCD__GAME_PHASE_NORMAL = 0
};

/// Constant 'GAME_PHASE_PENALTYSHOOT'.
enum
{
  rcgcd_spl_14__msg__RCGCD__GAME_PHASE_PENALTYSHOOT = 1
};

/// Constant 'GAME_PHASE_OVERTIME'.
enum
{
  rcgcd_spl_14__msg__RCGCD__GAME_PHASE_OVERTIME = 2
};

/// Constant 'GAME_PHASE_TIMEOUT'.
enum
{
  rcgcd_spl_14__msg__RCGCD__GAME_PHASE_TIMEOUT = 3
};

/// Constant 'STATE_INITIAL'.
enum
{
  rcgcd_spl_14__msg__RCGCD__STATE_INITIAL = 0
};

/// Constant 'STATE_READY'.
enum
{
  rcgcd_spl_14__msg__RCGCD__STATE_READY = 1
};

/// Constant 'STATE_SET'.
enum
{
  rcgcd_spl_14__msg__RCGCD__STATE_SET = 2
};

/// Constant 'STATE_PLAYING'.
enum
{
  rcgcd_spl_14__msg__RCGCD__STATE_PLAYING = 3
};

/// Constant 'STATE_FINISHED'.
enum
{
  rcgcd_spl_14__msg__RCGCD__STATE_FINISHED = 4
};

/// Constant 'SET_PLAY_NONE'.
enum
{
  rcgcd_spl_14__msg__RCGCD__SET_PLAY_NONE = 0
};

/// Constant 'SET_PLAY_GOAL_KICK'.
enum
{
  rcgcd_spl_14__msg__RCGCD__SET_PLAY_GOAL_KICK = 1
};

/// Constant 'SET_PLAY_PUSHING_FREE_KICK'.
enum
{
  rcgcd_spl_14__msg__RCGCD__SET_PLAY_PUSHING_FREE_KICK = 2
};

/// Constant 'SET_PLAY_CORNER_KICK'.
enum
{
  rcgcd_spl_14__msg__RCGCD__SET_PLAY_CORNER_KICK = 3
};

/// Constant 'SET_PLAY_KICK_IN'.
enum
{
  rcgcd_spl_14__msg__RCGCD__SET_PLAY_KICK_IN = 4
};

/// Constant 'SET_PLAY_PENALTY_KICK'.
enum
{
  rcgcd_spl_14__msg__RCGCD__SET_PLAY_PENALTY_KICK = 5
};

// Include directives for member types
// Member 'teams'
#include "rcgcd_spl_14/msg/detail/team_info__struct.h"

/// Struct defined in msg/RCGCD in the package rcgcd_spl_14.
typedef struct rcgcd_spl_14__msg__RCGCD
{
  uint8_t packet_number;
  uint8_t players_per_team;
  uint8_t competition_phase;
  uint8_t competition_type;
  uint8_t game_phase;
  uint8_t state;
  uint8_t set_play;
  uint8_t first_half;
  uint8_t kicking_team;
  int16_t secs_remaining;
  int16_t secondary_time;
  rcgcd_spl_14__msg__TeamInfo teams[2];
} rcgcd_spl_14__msg__RCGCD;

// Struct for a sequence of rcgcd_spl_14__msg__RCGCD.
typedef struct rcgcd_spl_14__msg__RCGCD__Sequence
{
  rcgcd_spl_14__msg__RCGCD * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcgcd_spl_14__msg__RCGCD__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCGCD_SPL_14__MSG__DETAIL__RCGCD__STRUCT_H_
