// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcgcd_spl_14:msg/TeamInfo.idl
// generated code does not contain a copyright notice
#include "rcgcd_spl_14/msg/detail/team_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `players`
#include "rcgcd_spl_14/msg/detail/robot_info__functions.h"

bool
rcgcd_spl_14__msg__TeamInfo__init(rcgcd_spl_14__msg__TeamInfo * msg)
{
  if (!msg) {
    return false;
  }
  // team_number
  // team_colour
  // score
  // penalty_shot
  // single_shots
  // message_budget
  // players
  for (size_t i = 0; i < 7; ++i) {
    if (!rcgcd_spl_14__msg__RobotInfo__init(&msg->players[i])) {
      rcgcd_spl_14__msg__TeamInfo__fini(msg);
      return false;
    }
  }
  return true;
}

void
rcgcd_spl_14__msg__TeamInfo__fini(rcgcd_spl_14__msg__TeamInfo * msg)
{
  if (!msg) {
    return;
  }
  // team_number
  // team_colour
  // score
  // penalty_shot
  // single_shots
  // message_budget
  // players
  for (size_t i = 0; i < 7; ++i) {
    rcgcd_spl_14__msg__RobotInfo__fini(&msg->players[i]);
  }
}

bool
rcgcd_spl_14__msg__TeamInfo__are_equal(const rcgcd_spl_14__msg__TeamInfo * lhs, const rcgcd_spl_14__msg__TeamInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // team_number
  if (lhs->team_number != rhs->team_number) {
    return false;
  }
  // team_colour
  if (lhs->team_colour != rhs->team_colour) {
    return false;
  }
  // score
  if (lhs->score != rhs->score) {
    return false;
  }
  // penalty_shot
  if (lhs->penalty_shot != rhs->penalty_shot) {
    return false;
  }
  // single_shots
  if (lhs->single_shots != rhs->single_shots) {
    return false;
  }
  // message_budget
  if (lhs->message_budget != rhs->message_budget) {
    return false;
  }
  // players
  for (size_t i = 0; i < 7; ++i) {
    if (!rcgcd_spl_14__msg__RobotInfo__are_equal(
        &(lhs->players[i]), &(rhs->players[i])))
    {
      return false;
    }
  }
  return true;
}

bool
rcgcd_spl_14__msg__TeamInfo__copy(
  const rcgcd_spl_14__msg__TeamInfo * input,
  rcgcd_spl_14__msg__TeamInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // team_number
  output->team_number = input->team_number;
  // team_colour
  output->team_colour = input->team_colour;
  // score
  output->score = input->score;
  // penalty_shot
  output->penalty_shot = input->penalty_shot;
  // single_shots
  output->single_shots = input->single_shots;
  // message_budget
  output->message_budget = input->message_budget;
  // players
  for (size_t i = 0; i < 7; ++i) {
    if (!rcgcd_spl_14__msg__RobotInfo__copy(
        &(input->players[i]), &(output->players[i])))
    {
      return false;
    }
  }
  return true;
}

rcgcd_spl_14__msg__TeamInfo *
rcgcd_spl_14__msg__TeamInfo__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcd_spl_14__msg__TeamInfo * msg = (rcgcd_spl_14__msg__TeamInfo *)allocator.allocate(sizeof(rcgcd_spl_14__msg__TeamInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcgcd_spl_14__msg__TeamInfo));
  bool success = rcgcd_spl_14__msg__TeamInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcgcd_spl_14__msg__TeamInfo__destroy(rcgcd_spl_14__msg__TeamInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcgcd_spl_14__msg__TeamInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcgcd_spl_14__msg__TeamInfo__Sequence__init(rcgcd_spl_14__msg__TeamInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcd_spl_14__msg__TeamInfo * data = NULL;

  if (size) {
    data = (rcgcd_spl_14__msg__TeamInfo *)allocator.zero_allocate(size, sizeof(rcgcd_spl_14__msg__TeamInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcgcd_spl_14__msg__TeamInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcgcd_spl_14__msg__TeamInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcgcd_spl_14__msg__TeamInfo__Sequence__fini(rcgcd_spl_14__msg__TeamInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcgcd_spl_14__msg__TeamInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcgcd_spl_14__msg__TeamInfo__Sequence *
rcgcd_spl_14__msg__TeamInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcgcd_spl_14__msg__TeamInfo__Sequence * array = (rcgcd_spl_14__msg__TeamInfo__Sequence *)allocator.allocate(sizeof(rcgcd_spl_14__msg__TeamInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcgcd_spl_14__msg__TeamInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcgcd_spl_14__msg__TeamInfo__Sequence__destroy(rcgcd_spl_14__msg__TeamInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcgcd_spl_14__msg__TeamInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rcgcd_spl_14__msg__TeamInfo__Sequence__are_equal(const rcgcd_spl_14__msg__TeamInfo__Sequence * lhs, const rcgcd_spl_14__msg__TeamInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcgcd_spl_14__msg__TeamInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcgcd_spl_14__msg__TeamInfo__Sequence__copy(
  const rcgcd_spl_14__msg__TeamInfo__Sequence * input,
  rcgcd_spl_14__msg__TeamInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcgcd_spl_14__msg__TeamInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rcgcd_spl_14__msg__TeamInfo * data =
      (rcgcd_spl_14__msg__TeamInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcgcd_spl_14__msg__TeamInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rcgcd_spl_14__msg__TeamInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcgcd_spl_14__msg__TeamInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
